;Ctools  v1.1b
;-----
;by Levi Lansing
;--puzzlesome@hotmail.com
;--http://www.crosswinds.net/levisti86/

;This is an interrupt program that will allow you to adjust the contrast, hide the run indicator,
;and power down the calc at almost any time

;by the way, this was made in Assembly Studio 86 v3.0 so if you have v3.1, you
;may have to change the header files...

#include "asm86.h"
#include "ti86asm.inc"

_user_int_ram EQU $d2fd
_user_on_int_ram EQU $d48f		;not used


.org _asm_exec_ram
	nop													;\
	jp Start											; \
.dw $0000												;  \Ashell
.dw Title												;  /stuff
Title:													; /
	.db "Tools  on  the  go  -  v1.1",0					;/


Start:
  call _runindicoff
  call _flushallmenus	;close all open menus
  call _homeup			;move the cursor to the top left of the screen
  ld de,CoolTITLE
  call decompV
  ld a,(OptionsData+5)	;Display the status of CT (enabled, or disabled)
  bit 3,a
  jr nz,E
D:
  ld hl,Disabled
  jr DE
E:
  ld hl,Enabled
DE:
  ld bc,$0F01			;Display all the labels
  call PutText
  ld hl,OptionsText
  ld bc,$1C0C
  call PutText
  ld bc,$1413
  call PutText
  ld bc,$1419
  call PutText
  ld bc,$141F
  call PutText
  ld bc,$2026
  call PutText
  ld bc,$142D
  call PutText
  ld bc,$1433
  call PutText
  ld bc,$1439
  call PutText

  ld bc,$4E13			;display CT's run indicator speed value
;  ld a,(APDVALUE+1)
;  ld (OptionsData),a
  ld a,(OptionsData)
  cp 0
  jr nz,CTrunON
  ld hl,Disabled
  call PutText
  jr BAT
CTrunON:
  ld hl,(OptionsData)
  call PutNum
BAT:						;I was going to put in a battery meter...
							;maybe later
;  ld bc,$4E19
;  ld a,(OptionsData+2)
;  cp 0
;  jr z,BAToff
;  ld hl,Enabled
;  call PutText
;  jr APDcntr
;BAToff:
;  ld hl,Disabled
;  call PutText
APDcntr:					;display the speed of the APD timer
  ld bc,$4E19
  ld hl,(OptionsData+3)
  xor a
  cp l
  jr nz,putAPD
  ld hl,Default
  call PutText
  jr OPT5
putAPD:
  call PutNum
OPT5:						;display Enabled or Disabled for the next 3 options
  ld bc,$4E2D
  ld a,(OptionsData+5)
  push af
  bit 2,a					;Run indicator hider
  call enORdi
  ld bc,$4E33
  pop af
  push af
  bit 1,a					;Quick off
  call enORdi
  ld bc,$4E39
  pop af
  bit 0,a					;Contrast
  call enORdi

  ld b,1
  call drawHIGHLIGHT		;draw the highlight on the first option

  bit 2,(iy+$23)		;is the user interrupt on?
  jr nz,Re_ld
;****this is from Jimmy Mardell's zTetris source, but it is very modified

	; All this stuff is to make sure the hiscore table
	; and resume stuff are stored in the variable

	ld hl,ProgName			; point hl to the programdata and name
	rst 20h					; same as _MOV10TOOP1 routine - copies the prog data to OP1
	rst 10h					; same as _FINDSYM - finds the specified program and points
							; BDE to it (absolute address)
	ex de,hl				; we need the abs address to be in AHL, so we exchange de and hl...
	ld a,b					; and then load a with b  -  now ahl = bde
	ld de,Settings-$D748+4	; DE = relative offset to stuff to store (-4)
	add hl,de				; point hl to that part of the program
	adc a,0					; Next block if necessary - I'm not totally sure what this does, but I think it
							; has something to do with the routine at $46C3
	ld de,var+1				; DE = start of bytes to copy
	call $46C3				; I believe this loads the proper ram page for the absolute address stored in AHL
	ld a,(de)				; Read the byte from the interrupt memory
	cp 16					; check if it's 16, if there is no carry (nc) the then byte is bigger than 16
    jp nc,Re_ld				; if the byte is 16 or bigger, a different interrupt is here so we are
							; going to reload CoolTool into the interrupt memory and turn it on
	ld (hl),a				; And save it in the program memory

  jr MenuLoop

Re_ld:
  call Reload
  jr MenuLoop

Reload:
   res 2,(iy+$23)		;turn user int off so it won't get called by
                     	;accident before we're ready
				;first we want to clear the interrupt for neatness (mainly for debugging)
 ld hl,$d2fd	;point hl to interrupt RAM
 ld (hl),$5A	;$5A is the standard checksum for a blank interrupt
 inc hl			
 ld (hl),0		;clear the next byte
 ld de,$d2ff	;point de to the byte after hl
 ld bc,199		;we only have to clear 199 bytes (of 200) since we 1st cleared the 1st
 ldir			;clear it out

   ld hl,int         		;hl point to the begining of the program
   ld de,_user_int_ram+1	;de pionts to where the program is to be loaded
   ld bc,int_end-int		;bc is the length of the program to be sent
   ldir						;copies it
   
   ld a,(_user_int_ram+1)		;this sets up checksum byte - 
   ld hl,_user_int_ram+($28*1)	;we need to add the 1st bite with another one
   add a,(hl)					;every 40 bytes and store it in the...
   ld hl,_user_int_ram+($28*2)
   add a,(hl)
   ld hl,_user_int_ram+($28*3)
   add a,(hl)
   ld hl,_user_int_ram+($28*4)
   add a,(hl)
   ld hl,_user_int_ram+($28*5)
   add a,(hl)
   ld (_user_int_ram),a			;first byte of the interrupt area

   set 2,(iy+$23)	;turn on the interrupt
  ret


MenuLoop:
  call _getky		;check for a key
  cp K_EXIT
  jp z,EXIT			;exit if exit was pushed
  push af
  cp K_DOWN
  call z,Mdown		;if down was pressed, move down
  pop af
  push af
  cp K_UP
  call z,Mup		;move up if up was pressed
  pop af
  push af
  cp K_RIGHT
  call z,Mright		;change value RIGHT
  pop af
  cp K_LEFT
  call z,Mleft		;change value LEFT
  jr MenuLoop

EXIT:				;change all the settings and reload if necessary
  ld a,(OptionsData)	;this will be rather confusing...
  cp 0					;basicly, in this section we will check all the changed
  jr z,noBLINK			;settings and apply them to the interrupt program...
  ld hl,CTRIDELAY+1
  ld (hl),a
  ld de,$C221
  ld (CTRIDELAY-4),de
  jr APDvalCHANGE
noBLINK:
  ld de,$1416
  ld (CTRIDELAY-4),de
APDvalCHANGE:
  ld a,(OptionsData+3)
  cp 0
  jr nz,changeAPDval
  ld hl,APDSTART
  ld (hl),$18
  inc hl
  ld (hl),$0F
  jr NOchangeAPDval
changeAPDval:
  ld hl,APDSTART
  ld (hl),$21
  inc hl
  ld (hl),$0A
  ld (APDVALUE+1),a
NOchangeAPDval:
  ld a,(OptionsData+5)
  push af
  ld hl,F2TEST
  bit 2,a
  jr nz,BIT2on
  ld (hl),$18
  jr BIT1
BIT2on:
  ld (hl),$20
BIT1:
  pop af
  push af
  ld hl,F3TEST
  bit 1,a
  jr nz,BIT1on
  ld (hl),0
  inc hl
  ld (hl),0
  jr BIT0
BIT1on:
  ld (hl),$28
  inc hl
  ld (hl),$55
BIT0:
  pop af
  ld hl,F4TEST
  bit 0,a
  jr nz,BIT0on
  ld (hl),0
  inc hl
  ld (hl),0
  ld hl,F5TEST
  ld (hl),0
  inc hl
  ld (hl),0
  jr BITdone
BIT0on:
  ld (hl),$28
  inc hl
  ld (hl),$2C
  ld hl,F5TEST
  ld (hl),$28
  inc hl
  ld (hl),$2E
BITdone:		;now we will copy the option data and the interrupt program
				;back into the memory for this program so it will be here next
				;time it is run
	ld hl,ProgName        ; All this stuff is to make sure the hiscore table
	rst 20h	       ; and resume stuff are stored in the variable
	rst 10h
	ex de,hl	       ; HL -> start of variable
	ld a,b
	ld de,OptionsData-$D748+4  ; DE = relative offset to stuff to store (-4)
	add hl,de
	adc a,0	       ; Next block if necessary
	ld de,OptionsData	       ; DE = start of bytes to copy
	ld b,int_end-OptionsData	       ; copy the whole interrupt program and the options data
RepCopy:
	push af
	push hl
	call $46C3
	ld a,(de)	       ; Read
	ld (hl),a	       ; And save it in the real variable
	pop hl
	pop af
	call $4637
	inc de
	djnz RepCopy

  call Reload			;reload the interrupt program into the interrupt RAM and turn it on

  ld a,(OptionsData+5)
  bit 3,a
  jr nz,CTen
  res 2,(iy+$23)		;turn off the interrupt if CT is set to disabled
CTen:
  call _clrScrn

  ld hl,KeyCommands		;display the commands
  ld bc,$0101
  call PutText			;title: KEY COMMANDS
  ld bc,$010A
  call PutText			;F1+F2
  ld bc,$0112
  call PutText			;F1+F3
  ld bc,$011A
  call PutText			;F1+F4
  ld bc,$0122
  call PutText			;F1+F5
  ld bc,$012C
  call PutText			;email me-
  ld a,05
  ld (_penCol),a
  ld a,48
  ld (_penRow),a
  call _vputs			;puzzlesome@hotmail.com
  ld a,6
  ld (_curRow),a
  call _getkey
  ret					;exit from this program

Mdown:					;erases the old highlight and draws the new one down one line
  ld hl,MenuPos+1
  ld b,(hl)
  dec hl
  ld (hl),b
  inc hl
  inc (hl)
  ld c,(hl)
  ld a,c
  cp 7
  jr nz,MDcont
  ld (hl),1
  ld c,1
MDcont:
  call drawHIGHLIGHT
  ld b,c
  call drawHIGHLIGHT
  ret

Mup:					;erases the old highlight and draws the new one up one line
  ld hl,MenuPos+1
  ld b,(hl)
  dec hl
  ld (hl),b
  inc hl
  dec (hl)
  ld c,(hl)
  ld a,c
  cp 0
  jr nz,MDcont
  ld (hl),6
  ld c,6
MUcont:
  call drawHIGHLIGHT
  ld b,c
  call drawHIGHLIGHT
  ret

Mright:					;changes the highlighted value (right goes up)
  ld a,(MenuPos+1)
  cp 1
  jr nz,M_2
M_1LC:					;CT on/off
  ld hl,OptionsData+5
  push hl
  ld a,(hl)
  bit 3,a
  jr nz,E1
  ld hl,Disabled
  jr DE1
E1:
  ld hl,Enabled
DE1:
  ld bc,$0F01
  call PutText
  pop hl
  ld a,%00001000
  xor (hl)
  ld (hl),a
  bit 3,a
  jr nz,E10
  ld hl,Disabled
  jr DE10
E10:
  ld hl,Enabled
DE10:
  ld bc,$0F01
  call PutText
  ret

M_2:				;CT's run indicator speed
  cp 2
  jr nz,M_3
M_2LC:
  ld bc,$4E13
  ld hl,OptionsData
  push hl
  ld a,(hl)
  cp 0
  jr z,DE2
  ld hl,(OptionsData)
  call PutNum
  jr M2cnt
DE2:
  xor a
  ld (OptionsData),a
  ld hl,Disabled
  call PutText
M2cnt:
  ld bc,$4E13
  pop hl
  inc (hl)
  inc (hl)
  ld a,(hl)
  cp 0
  jr z,DE02
  ld hl,(OptionsData)
  call PutNum
  ret
DE02:
  ld hl,Disabled
  call PutText
  ret

M_3:				;saving this for later use

;  cp 3
;  jr nz,M_4
;  ret

M_4:				;APD timer value
  cp 3
  jr nz,M_5
  ld bc,$4E19
  ld hl,OptionsData+3
  push hl
  ld a,(hl)
  cp 0
  jr z,DE4
  ld hl,(OptionsData+3)
  call PutNum
  jr M4cnt
DE4:
  ld hl,Default
  call PutText
M4cnt:
  ld bc,$4E19
  pop hl
  inc (hl)
  inc (hl)
  ld a,(hl)
  cp 0
  jr z,DE04
  ld hl,(OptionsData+3)
  call PutNum
  ret
DE04:
  ld hl,Default
  call PutText
  ret

M_5:					;run indicator hider
  cp 4
  jr nz,M_6
M_5LC:
  ld a,(OptionsData+5)
  bit 2,a
  jr nz,E5
  ld hl,Disabled
  jr DE5
E5:
  ld hl,Enabled
DE5:
  ld bc,$4E2D
  call PutText
  ld hl,OptionsData+5
  ld a,%00000100
  xor (hl)
  ld (hl),a
  bit 2,a
  jr nz,E50
  ld hl,Disabled
  jr DE50
E50:
  ld hl,Enabled
DE50:
  ld bc,$4E2D
  call PutText
  ret

M_6:				;quick off
  cp 5
  jr nz,M_7
M_6LC:
  ld a,(OptionsData+5)
  bit 1,a
  jr nz,E6
  ld hl,Disabled
  jr DE6
E6:
  ld hl,Enabled
DE6:
  ld bc,$4E33
  call PutText
  ld hl,OptionsData+5
  ld a,%00000010
  xor (hl)
  ld (hl),a
  bit 1,a
  jr nz,E60
  ld hl,Disabled
  jr DE60
E60:
  ld hl,Enabled
DE60:
  ld bc,$4E33
  call PutText
  ret

M_7:				;contrast adjustment
  cp 6
  ret nz
M_7LC:
  ld a,(OptionsData+5)
  bit 0,a
  jr nz,E7
  ld hl,Disabled
  jr DE7
E7:
  ld hl,Enabled
DE7:
  ld bc,$4E39
  call PutText
  ld hl,OptionsData+5
  ld a,%00000001
  xor (hl)
  ld (hl),a
  bit 0,a
  jr nz,E70
  ld hl,Disabled
  jr DE70
E70:
  ld hl,Enabled
DE70:
  ld bc,$4E39
  call PutText
  ret

Mleft:					;changes the highlighted value (left goes down)
  ld a,(MenuPos+1)
  cp 1					;CT on/off
  jp z,M_1LC
M_2L:
  cp 2					;CT run indicator speed
  jr nz,M_3L
  ld bc,$4E13
  ld hl,OptionsData
  push hl
  ld a,(hl)
  cp 0
  jr z,DE2L
  ld hl,(OptionsData)
  call PutNum
  jr M2cntL
DE2L:
  ld hl,Disabled
  call PutText
M2cntL:
  ld bc,$4E13
  pop hl
  dec (hl)
  dec (hl)
  ld a,(hl)
  cp 0
  jr z,DE02L
  ld hl,(OptionsData)
  call PutNum
  ret
DE02L:
  xor a
  ld (OptionsData),a
  ld hl,Disabled
  call PutText
  ret

M_3L:				;saving this for later use
;  cp 4
;  jr nz,M_4L
;  ret

M_4L:
  cp 3					;APD timer length
  jr nz,M_5L
  ld bc,$4E19
  ld hl,OptionsData+3
  push hl
  ld a,(hl)
  cp 0
  jr z,DE4L
  ld hl,(OptionsData+3)
  call PutNum
  jr M4cntL
DE4L:
  ld hl,Default
  call PutText
M4cntL:
  ld bc,$4E19
  pop hl
  dec (hl)
  dec (hl)
  ld a,(hl)
  cp 0
  jr z,DE04L
  ld hl,(OptionsData+3)
  call PutNum
  ret
DE04L:
  ld hl,Default
  call PutText
  ret
M_5L:
  cp 4					;Run indicator hider
  jp z,M_5LC
M_6L:
  cp 5					;quick off
  jp z,M_6LC
M_7L:
  cp 6					;contrast adjustment
  jp z,M_7LC
  ret

drawHIGHLIGHT:			;draws the highlight at bc
  push bc
  ld hl,MenuLocations-2
mLoop:
  inc hl
  inc hl
  djnz mLoop
  ld d,5
  ld b,(hl)
  inc hl
  ld c,(hl)
Hloop:
  push de
  ld ix,Highlight
  call TinySprite
  ld a,7
  add a,b
  ld b,a
  pop de
  dec d
  ld a,d
  cp 0
  jr nz,Hloop
  pop bc
  ret

enORdi:				;displays "Enabled" if the nz flag is set or "Disabled" if the z flag is set
  jr nz,enab
  ld hl,Disabled
  jp PutText
enab:
  ld hl,Enabled
  jp PutText


Enabled:
	.db "ENABLED",0
Disabled
	.db "DISABLED",0
Default:
	.db "DEFAULT",0	

OptionsText:
	.db "-PERMENENT OPTIONS-",0
	.db "CTS RUN INDIC:",0
	.db "APD COUNTDOWN:",0
	.db "",0
	.db "-RUNTIME OPTIONS-",0
	.db "RUN INDIC OPT:",0
	.db "QUICK PWR DWN:",0
	.db "CONTRAST ADJU:",0


MenuLocations:
	.db $0E,$00, $4D,$12, $4D,$18 
;	.db $4D,$1E						;this is where the space is
	.db $4D,$2C, $4D,$32, $4D,$38
MenuPos:
	.db 1,1		;old, new

;Text Data
KeyCommands:
;	.db "    Cool Tool v1.1   ",0
	.db "KEY COMMANDS:",0
	.db "F1+F2: TOGGLE RUN INDICATOR",0
	.db "F1+F3: QUICK POWER DOWN",0
	.db "F1+F4: CONTRAST DOWN",0
	.db "F1+F5: CONTRAST UP",0
	.db "EMAIL ME:",0
	.db "puzzlesome@hotmail.com",0
ProgName:
	.db $12,$08,"CoolTool"

PutNum:			;hl=num to convert		;displays the value in hl
 push bc
 ld de,Temp2+2
 ld b,3
Conv2Loop:
 call UNPACK_HL
 add a,'0'
 ld (de),a
 dec de
 djnz Conv2Loop
; ld bc,$7032		;bc=location to print
 ld hl,Temp2
 pop bc
 call PutText		;print the numbers
 ret

Temp2:
	.db 0,0,0,0

;********************************************************
; -decompresses data that is vertically compressed with
; bmp2asm, by Levi Lansing    (total size=63 bytes)
; -(decompresses data into the video memory - 1024 bytes)
; -de=location of data to decompress
; -destroys- a,b,c,hl,de (points to byte after data)
;********************************************************
decompV:
 ld hl,$FC00        ;point hl to the screen mem
decompLoop:
 ld a,(de)          ;load the first byte of the compressed data
 cp $B7             ;check if it's a marker
 jr nz,DCnorm       ;if it's not, treat it as a normal byte
 inc de             ;if the byte is marked, the next byte tells us the value
 ld a,(de)          ;that is repeated so we
 ld c,a             ;put that in c
 inc de             ;the next byte tells us how many times it's repeated
 ld a,(de)
 ld b,a             ;we will load that into b to be used as a counter
 inc de             ;point to the next byte for later
DCrepeatLoop:
 ld (hl),c          ;put the value in the screen mem once
 push de            ;hide de
 ld de,16
 add hl,de          ;point hl to the next row (16 bytes forward)
 jr nc,DCloop       ;if hl isn't past the end of the screen data ($FFFF), then continue
 ld de,1022         ;if it is, we need to put it back to the next column
 sbc hl,de          ;point hl to the 1st row of the next column
 ld a, l
 cp $10             ;if l is over $10 (16d), it has completed the full screen
 jr c,DCloop        ;jump if it's no over $10 to continue
 pop de             ;restore de again
 ret                ;return from the routine
DCloop:
 pop de             ;restore de
 djnz DCrepeatLoop  ;decrement b and continue loading the same byte down the
                    ;column until b is 0
 jr decompLoop      ;continue with the next byte
DCnorm:
 ld (hl),a          ;load the byte into the screen mem
 inc de             ;point de to the next byte
 push de            ;hide it
 ld de, 16
 add hl,de          ;point hl to the next row (16 bytes forward)
 pop de             ;restore de
 jr nc,decompLoop   ;if hl did not go past $FFFF (it would flip to 0+) then continue
 push de            ;hide de again
 ld de, 1022
 sbc hl,de          ;subtracting 1022 from hl put's it at the 1st row of the next column
 ld a, l
 cp $10             ;check if hl is past the first row (if it is, we finished decompressing)
 pop de             ;restore de again
 jr c,decompLoop    ;if we're not done, keep going...
 ret                ;if we get here, we're done and will return from the routine


;*****All this places the custom font*****
doneT:
 pop bc
 pop hl
 inc hl
 ret

Ext:
 push af
 ld a,5
 ld (TextWidth),a
 pop af
 ret

Cspace:
 pop bc
 dec b
 dec b

next:
 pop hl
 ld a,(hl)
 cp 44
 jr nz,skip
 dec c
skip:
 inc hl
 ld a,(TextWidth)
 add a,b
 ld b,a 

PutText:			;this is what you call to display the text in hl
 ld a,4
 ld (TextWidth),a
 push hl
 push bc
 ld de,$0004
 ld a,(hl)
 cp 0
 jr z,doneT
 cp 77
 call z,Ext
 cp 78
 call z,Ext
 cp 81
 call z,Ext
 cp 87
 call z,Ext
 cp 32
 jr z,Cspace		;space
 cp 33
 jp z,Cexclaim
 cp 35
 jr z,Cblock
 cp 44
 jp z,Ccoma
 cp 46
 jr z,Cperiod
 cp 48
 jr c,Cundef
 cp 58
 jr z,Ccolon
 cp 59
 jr c,Cnum
 cp 63
 jr z,Cq
 cp 64
 jr z,Cat
 cp 65
 jr c,Cundef
 cp 73
 jr c,CalphaL
 cp 91
 jr c,CalphaR
Cundef:
 ld a,3
 ld (TextWidth),a
 ld ix,Undef
 jr putLeft

Cnum:
 ld ix,Font-4
 sub 47
 ld b,a
CNL:
 add ix,de
 djnz CNL
 jr putLeft

CalphaL:
 ld ix,StartA-4
 sub 64
 ld b,a
CaL:
 add ix,de
 djnz CaL
 jr putLeft

CalphaR:
 ld ix,Font
 sub 72
 ld b,a
CaR:
 add ix,de
 djnz CaR
 jr putRight


Cblock:
 call Ext
 ld ix,Undef
 jr putRight

Cperiod:
 ld ix,Font
 ld a,2
 ld (TextWidth),a
 jr putRight

Ccolon:
 call Ext
 ld ix,Colon
 jr putLeft

Cat:
 call Ext
 ld ix,Exclamation
 jr putRight

Cq:
 call Ext
 ld ix,Colon
 jr putRight

Ccoma:
 ld ix,Coma
 pop bc
 inc c
 dec b
 push bc
 jr putLeft

Cexclaim:
 call Ext
 ld ix,Exclamation
 ld a,2
 ld (TextWidth),a

putLeft:
 ld hl,Temp
 ld b,4
PLoop:
 ld a,(ix)
 ld (hl),0
 rrd
 ld (hl),a
 inc hl
 inc ix
 djnz PLoop
 pop bc
 ld ix,Temp
 call TinySprite
 jp next


putRight:
 ld hl,Temp
 ld b,4
PLoop1:
 ld a,(ix)
 ld (hl),0
 rld
 rld
 inc hl
 inc ix
 djnz PLoop1
 pop bc
 ld ix,Temp
 call TinySprite
 jp next

TextWidth:
	.db 3

;***************************************************
;TinySprite by Levi Lansing (puzzlesome@hotmail.com)
;   - the smallest putsprite I've seen (69 bytes)
;input-
;  ix-points to 8x8 sprite
;  bc-(x,y) location
;output-
;   the sprite!
;DESTROYS- a, d, e, hl, (ix-points to next sprite)
;***************************************************
TinySprite:
 push bc
 ld a,(DispLoc)
 ld h,a				;3F shifts to $FC with add hl,hl
 ld a,c
 add a,a			;a*4
 add a,a
 ld l,a
 xor a
 add hl,hl			;hl*4 (what was c has been mlt by 16)
 add hl,hl
 ld a,b				;a/8
 sra a
 sra a
 sra a
 or l				;add to more significant bytes
 ld l,a
 ld a,7				;use bottom 3 bits for counter (the # will be <8)
 and b
 ld d,a				;save counter copy in d
 ld e,8				;8 rows

ps_loop:
 ld b,d				;get saved bit offset in b
 ld a,(ix)			;get this byte of the sprite in a
 inc ix				;point ix to the next byte of the sprite
 ld c,0
 call bit_shift
 xor (hl)			;change this to 'or' or 'and' if you want
 ld (hl),a
 inc l
 jr nz,NoOver
 inc h
 xor a
 cp h
 ret z
NoOver:
 ld a,(hl)
 xor c				;also changable (if you changed the first)
 ld (hl),a
 ld a,15			;add 15 to hl (now ready for next row)
 call add_hl_a
 dec e				;counter (8 rows)
 jr nz,ps_loop
 pop bc
 ret

add_hl_a:			;add hl,a
 add a,l
 ld l,a
 ret nc
 inc h
 ret

bit_shift:			;while(b=<0)
 dec b				;a>>c
 ret m
 srl a
 rr c
 jr bit_shift

DispLoc:
 .db $3F


;*******font data********
Font:				;each char is 4x4, so 4 are put into each normal 8x8 sprite!
	.db %11100000
	.db %10100000
	.db %10100000
	.db %11101000
	.db %01001110
	.db %11000100
	.db %01000100
	.db %11101110

	.db %11101110
	.db %00100100
	.db %11000100
	.db %11101100
	.db %11101010
	.db %01101100
	.db %00101010
	.db %11101010

	.db %00101000
	.db %01101000
	.db %11101000
	.db %00101110
	.db %11100101
	.db %10001011
	.db %01101001
	.db %11101001

	.db %11101001
	.db %10001101
	.db %11101011
	.db %11101001
	.db %11101110
	.db %00101010
	.db %01001010
	.db %01001110

	.db %11101110
	.db %11101110
	.db %10101000
	.db %11101000
	.db %11101110
	.db %11101010
	.db %00101010
	.db %00101111

StartA:
	.db %01001100
	.db %10101010
	.db %11101100
	.db %10101010
	.db %11001110
	.db %11001100
	.db %10100010
	.db %11001110

	.db %01101110
	.db %10000100
	.db %10000100
	.db %01100100
	.db %11001010
	.db %10101010
	.db %10101010
	.db %11001110

	.db %11101010
	.db %11001010
	.db %10001010
	.db %11100100
	.db %11101001
	.db %10001001
	.db %11001101
	.db %10001010

	.db %01101010
	.db %10000100
	.db %10100100
	.db %01101010
	.db %10101010
	.db %10101010
	.db %11100100
	.db %10100100

Coma:
	.db %00001110
	.db %00000100
	.db %01001000
	.db %10001110

Colon:
	.db %00001100
	.db %10000010
	.db %00000100
	.db %10000100

Undef:
	.db %00001111
	.db %11001111
	.db %11001111
	.db %00001111

Exclamation:
	.db %10001111
	.db %10000001
	.db %00001101
	.db %10001111

Temp:
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000000

;-----end of font data-----

Highlight:
	.db %11111110
	.db %11111110
	.db %11111110
	.db %11111110
	.db %11111110
	.db %11111110
	.db %00000000
	.db %00000000


CoolTITLE:
;Compressed picture made with BMP2ASM by Levi Lansing (puzzlesome@hotmail.com)
;Compressed from 1024 bytes to 212 bytes - 79% compressed!
  .db $B7, $33, $09, $03, $33, $6B, $6B, $6B, $33, $03, $73, $6B, $6B, $73, $63, $63
  .db $03, $7B, $B7, $33, $04, $03, $7B, $33, $33, $33, $7B, $03, $33, $6B, $6B, $6B
  .db $33, $03, $4B, $6B, $5B, $4B, $03, $33, $6B, $33, $5B, $33, $03, $B7, $33, $0C
  .db $B7, $00, $FF, $B7, $00, $41, $B7, $01, $0A, $B7, $00, $36, $80, $9C, $A4, $A0
  .db $A1, $A5, $9C, $80, $FF, $FF, $B7, $00, $39, $C6, $29, $29, $C6, $00, $FF, $FF
  .db $B7, $00, $37, $60, $B7, $20, $04, $70, $00, $FF, $FF, $B7, $00, $37, $1F, $15
  .db $04, $04, $04, $0E, $00, $FF, $FF, $B7, $00, $39, $63, $94, $94, $63, $00, $FF
  .db $FF, $B7, $00, $37, $30, $10, $10, $90, $90, $38, $00, $FF, $FF, $B7, $00, $3A
  .db $02, $02, $01, $00, $FF, $FF, $B7, $00, $37, $08, $18, $08, $88, $88, $3E, $00
  .db $FF, $FF, $B7, $00, $37, $08, $18, $08, $08, $08, $BE, $00, $D0, $D0, $D0, $DE
  .db $C0, $DE, $D0, $DC, $D0, $DE, $C0, $D2, $D4, $C8, $C0, $DE, $C8, $C8, $DE, $C0
  .db $C0, $C0, $D0, $D0, $D0, $DE, $C0, $CC, $D2, $DE, $D2, $C0, $D2, $DA, $D6, $C0
  .db $CE, $D0, $CC, $C2, $DC, $C0, $DE, $C8, $C8, $DE, $C0, $D2, $DA, $D6, $C0, $CC
  .db $D0, $D6, $CC, $C0

OptionsData:
	.db 70,0		;ct's run indicator
	.db 0			;nothing right now
	.db $40,0		;apd timer
	.db %00001111	;bit 3-CT on/off ;bit 2-run indic opt;  bit 1-qpd;  bit 0-contrast

;this is the end of this program.  Following is the interrupt program that will be
;coppied into the interrupt memory.



;**********************************************************************************
;By the way, if I were you and if you don't know exactly what you were doing,
;I wouldn't add on to this interrupt program because an interrupt program can only
;be a maximum of 200 bytes.  This one is 177 (reduced from 196) bytes and intricatly
;compacted to be that small.  Also remember with interrupts, if any data is changed
;on a byte that is included in the checksum (byte 0, 40, 80, 120, 160, or 200) while
;the interrupt is running, the checksum must be recalculated before the interrupt is
;executed next time or the interrupt won't run.
;**********************************************************************************




int:		;this is the begining of the program that will be copied into the user int mem
  push af			;when you run an interrupt, you can't change ANY registers
  push bc			;so you must push all the regesters you use
  push de
  push hl			;and pop (restore) them at the end
APDSTART:
  ld hl,$C00A		;point hl to the APD counter byte
  ld a,$A2
  cp (hl)
  jr nz,APDcnt
  ld (hl),$A0
APDcnt:
  ld a,$A1
  cp (hl)			;check if it's $A1: if it is $A1...
  jr nz,APDok		;don't change it (the TI-os resets it to $A1 when a key is pressed)
APDVALUE:			;this label is used to find and replace the APD timer value
  ld (hl),$40		;if it's been reset we will make it $40
APDok:

;I took this section out because I decided to not force the APD timer to run while
;in an assembly program because a select few will crash if the calc is turned off.
;
;  ld a,%10000000	;don't mask anything out (bit 7 does nothing that I know of, but
;					;if I use 0, it messes up the whole program on my calculator, but
;					;but not on my emulator (VTI) ???  Can anyone explain this?
;  out (1),a			;out to the port
;  in a,(1)			;read the results
;  cp $FF			;$FF is returned if no keys were pressed
;  jr z,NOkeyPressed
;  ld a,$40			;$40 is where we want to start the APD timer
;  ld ($C00A),a		;load $40 into the timer value
;NOkeyPressed:

  ld hl,var+1		;var+1 is the settings byte
  push hl			;hide hl in the top of the stack
  bit 1,(hl)		;check if the run indicator needs to be turned off and cleared
  jr z,RunOK		;skip this stuff if it is to be on
  bit 0,(iy+18)		;check if the run indicator is going
  jr z,RunOK		;if it's not, skip this stuff
  ;res 0,(iy+18)	;this would turn off the run indicator, but we just want to cover it up
  ld hl,$FC1F		;point hl to the 1 line below the top of the run indicator
  ld de,16			;16 bytes per row in the video mem
  ld b,7			;clear 7 lines of 8 of the run indicator area
RunClear:
  res 0,(hl)		;clear the bit
  add hl,de			;move to the next row
  djnz RunClear		;do this 7 times- we skipped the 1 line because that's where
					;CoolTool's run indicator is.
RunOK:
  pop hl			;restore hl (pointing to the settings byte)
  res 2,(hl)		;used later if F5 or F4 is pushed with F1
  ld a,%00111111	;key port mask
  out (1),a			;send it to the key port
  in a,(1)			;get it back
  bit 4,a			;F1 key
  jr nz,noF1
  bit 2,a			;F3 key
F3TEST:
  jr z,Off
  bit 0,a			;F5 key
F5TEST:
  jr z,UP			;you are holding F1 and F5, so we will turn it up
  bit 1,a			;F4 key
F4TEST:
  jr z,DOWN			;you are holding F1 and F4, so we will turn it down
  ;bit 3,(hl)
  bit 3,a			;check if F2 is pushed down
F2TEST:
  jr nz,noF2		;if it's not, goto noF2
  bit 3,(hl)		;check if the key has been held down since last time
  jr nz,noF1		;if it has (nz=1) don't toggle the run indicator hider
  jr RunINDIC		;toggle the option to hide the run indicator
noF2:
  res 3,(hl)		;we get here if F2 is not being pressed, so we tell the program it has been released
noF1:
  inc hl			;point to var+2
  ld (hl),1			;this way as soon as you push F1+F5 or F4 the contrast will change,
					;then the delay will become active for the next change while you hold it
cont:
  ld hl,var			;var is the counter which creates the delay
  inc (hl)			;it's increased by one everytime the interupt occurs
CTRIDELAY:
  ld a,70			;delay for the blinker
  cp (hl)			;if it is not 100
  jr nz,done		;we will quit the interrupt if it's not done counting
  ld (hl),0			;if the counter has counted down, restore it with the speed
  ld hl,$FC0F		;point to the last byte of the first line
  ld a,1			;a=%00000001
  xor (hl)			;inverse the last bit of the byte
  ld (hl),a			;store it back in the video memory
  res 4,(iy+$09)	;tell the calc you didn't push the on key if you did (to avoid break errors)
done:
   pop hl		;restore our variables in the opposite order we pushed them
   pop de
   pop bc
   pop af
   ret			;return from the interrupt

UP:
  set 2,(hl)	;this will be checked later and if it is set the contrast will be increased
DOWN:
  inc hl			;point to var+2
  dec (hl)			;dec the counter
  ld a,(hl)			;load it into a (zero flag will be set if it is 0)
  jr nz,cont		;if it was not zero
  ld (hl),$20		;$20 is the length of the delay between contrast changes
  dec hl			;point to var+1
  bit 2,(hl) 		;check if we need to go up or down
  ld hl,$C008		;load contrast value- we will need this later in the UP/DOWN_cont routines
  jr z,DOWN_cont	;if bit 2 is 0, we need to go down,
					;if bit 2 is 1, we need to go up-so we just continue
UP_cont:
  ld a,(hl)			;load the contrast value into a
  cp 31				;check if the contrast is at max
  jr z,cont			;if it is, jump to start (don't increase it)
  inc (hl)			;increase the contrast and write it back to memory
TOcontrastPORT:
  ld a,(hl)			;put the contrast value into a
  out (2),a			;and send it to the port (to change it on the screen)
  jr cont			;continue counting down

DOWN_cont:
  xor a					;a = 0
  cp (hl)				;check if the contrast is at min
  jr z,cont				;if it is, jump to start (don't decrease it)
  dec (hl)				;decrease the contrast directly in the mem
  jr TOcontrastPORT		;this saves 2 bytes by not haveing to repeat
						;the last 3 commands in the UP routine
Off:
  ld a,1            ;Set APD timer 
  ld ($C00A),a		;to the last value
  ld ($C009),a		;before it shuts off the calc
  set 3,(iy+$08)	;make sure the APD timer is running
  ;ld hl,var+1		;point hl to the settings - hl is already at var+1
  dec hl			;point to CoolTool's run indicator delay
  ld (hl),a			;load it with 1 so that it won't turn off the onkey flag too soon
  jr cont			;continue with CoolTool's run indicator stuff

RunINDIC:
  ;ld hl,var+1		;hl is already at var+1
  set 3,(hl)		;change the setting to say F2 was just pushed
  ld a,%00000010	;we need a 1 in bit to so when we
  xor (hl)			;xor it with hl, it inverses (toggles) the setting
  ld (hl),a			;load it into the memory
  jr cont			;continue with CoolTool's run indicator stuff

;var equ $-int+_user_int_ram+1
var equ $D3C2
  .db 50
Settings:		;the interrupt doesn't use this label, but when the interrupt is turned off,
				;this program needs to find this value so it can write it back to the actual program mem
  .db 0								;tells us if:
									;bit 0 = nothing (it was used, but isn't needed anymore)
									;bit 1 = the run indicator is to be kept off (1) or not (0)
									;bit 2 = Contrast needs to go up (1) or down (0)
									;bit 3 = the Run indic off routine was run and F2 is still pressed (1)
									        ;or F2 has been let off since the routine was last run (0)
;Speed of the contrast change (counter)
  .db 1
int_end:



.end		;All DONE!

